=== modified file 'NEWS'
--- NEWS	2008-03-23 23:11:45 +0000
+++ NEWS	2008-03-25 07:16:50 +0000
@@ -58,6 +58,11 @@
 
   TESTING:
 
+    * New -Dselftest_debug flag disables clearing of the debug flags during
+      tests.  This is useful if you want to use e.g. -Dhpss to help debug a
+      failing test.  Be aware that using this feature is likely to cause
+      spurious test failures if used with the full suite. (Andrew Bennetts)
+
   INTERNALS:
 
 

=== modified file 'bzrlib/debug.py'
--- bzrlib/debug.py	2008-03-01 12:42:12 +0000
+++ bzrlib/debug.py	2008-03-25 07:16:50 +0000
@@ -38,5 +38,6 @@
  * lock - trace when lockdir locks are taken or released
  * merge - emit information for debugging merges
  * pack - emit information about pack operations
+ * selftest_debug - do not disable all debug flags when running selftest
 
 """

=== modified file 'bzrlib/tests/__init__.py'
--- bzrlib/tests/__init__.py	2008-03-16 10:45:53 +0000
+++ bzrlib/tests/__init__.py	2008-03-25 07:16:50 +0000
@@ -811,9 +811,10 @@
         Tests that want to use debug flags can just set them in the
         debug_flags set during setup/teardown.
         """
-        self._preserved_debug_flags = set(debug.debug_flags)
-        debug.debug_flags.clear()
-        self.addCleanup(self._restore_debug_flags)
+        if 'selftest_debug' not in debug.debug_flags:
+            self._preserved_debug_flags = set(debug.debug_flags)
+            debug.debug_flags.clear()
+            self.addCleanup(self._restore_debug_flags)
 
     def _clear_hooks(self):
         # prevent hooks affecting tests

=== modified file 'bzrlib/tests/test_osutils.py'
--- bzrlib/tests/test_osutils.py	2008-03-07 20:24:05 +0000
+++ bzrlib/tests/test_osutils.py	2008-03-25 07:16:50 +0000
@@ -1118,6 +1118,7 @@
  * lock - trace when lockdir locks are taken or released
  * merge - emit information for debugging merges
  * pack - emit information about pack operations
+ * selftest_debug - do not disable all debug flags when running selftest
 
 """
 '''

